package eu.transkribus.swt_gui.auth;

import eu.transkribus.client.oidc.ITokenStorage;
import eu.transkribus.swt_gui.TrpGuiPrefs;

import java.util.List;
import java.util.Objects;

public class TrpGuiPrefsTokenStorage implements ITokenStorage {
    @Override
    public List<String> getUsernames() {
        return TrpGuiPrefs.getSsoUsernames();
    }

    @Override
    public String getStoredRefreshToken(String username) {
        return TrpGuiPrefs.getSsoToken(username);
    }

    @Override
    public void updateStoredRefreshToken(String username, String refreshToken) {
        Objects.requireNonNull(username);
        if(refreshToken == null) {
            TrpGuiPrefs.clearSsoToken(username);
        } else {
            TrpGuiPrefs.storeSsoToken(username, refreshToken);
        }
    }
}
